/*
CRM API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package crmapi

import (
	"encoding/json"
)

// checks if the DynamicAddressesListRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DynamicAddressesListRequest{}

// DynamicAddressesListRequest struct for DynamicAddressesListRequest
type DynamicAddressesListRequest struct {
	Plz *int64 `json:"plz,omitempty"`
	District *string `json:"district,omitempty"`
	City *string `json:"city,omitempty"`
	Street *string `json:"street,omitempty"`
	HouseNumber *int64 `json:"house_number,omitempty"`
	HouseNumberVariant *string `json:"house_number_variant,omitempty"`
	Lat *string `json:"lat,omitempty"`
	Lng *string `json:"lng,omitempty"`
}

// NewDynamicAddressesListRequest instantiates a new DynamicAddressesListRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDynamicAddressesListRequest() *DynamicAddressesListRequest {
	this := DynamicAddressesListRequest{}
	return &this
}

// NewDynamicAddressesListRequestWithDefaults instantiates a new DynamicAddressesListRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDynamicAddressesListRequestWithDefaults() *DynamicAddressesListRequest {
	this := DynamicAddressesListRequest{}
	return &this
}

// GetPlz returns the Plz field value if set, zero value otherwise.
func (o *DynamicAddressesListRequest) GetPlz() int64 {
	if o == nil || IsNil(o.Plz) {
		var ret int64
		return ret
	}
	return *o.Plz
}

// GetPlzOk returns a tuple with the Plz field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesListRequest) GetPlzOk() (*int64, bool) {
	if o == nil || IsNil(o.Plz) {
		return nil, false
	}
	return o.Plz, true
}

// HasPlz returns a boolean if a field has been set.
func (o *DynamicAddressesListRequest) HasPlz() bool {
	if o != nil && !IsNil(o.Plz) {
		return true
	}

	return false
}

// SetPlz gets a reference to the given int64 and assigns it to the Plz field.
func (o *DynamicAddressesListRequest) SetPlz(v int64) {
	o.Plz = &v
}

// GetDistrict returns the District field value if set, zero value otherwise.
func (o *DynamicAddressesListRequest) GetDistrict() string {
	if o == nil || IsNil(o.District) {
		var ret string
		return ret
	}
	return *o.District
}

// GetDistrictOk returns a tuple with the District field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesListRequest) GetDistrictOk() (*string, bool) {
	if o == nil || IsNil(o.District) {
		return nil, false
	}
	return o.District, true
}

// HasDistrict returns a boolean if a field has been set.
func (o *DynamicAddressesListRequest) HasDistrict() bool {
	if o != nil && !IsNil(o.District) {
		return true
	}

	return false
}

// SetDistrict gets a reference to the given string and assigns it to the District field.
func (o *DynamicAddressesListRequest) SetDistrict(v string) {
	o.District = &v
}

// GetCity returns the City field value if set, zero value otherwise.
func (o *DynamicAddressesListRequest) GetCity() string {
	if o == nil || IsNil(o.City) {
		var ret string
		return ret
	}
	return *o.City
}

// GetCityOk returns a tuple with the City field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesListRequest) GetCityOk() (*string, bool) {
	if o == nil || IsNil(o.City) {
		return nil, false
	}
	return o.City, true
}

// HasCity returns a boolean if a field has been set.
func (o *DynamicAddressesListRequest) HasCity() bool {
	if o != nil && !IsNil(o.City) {
		return true
	}

	return false
}

// SetCity gets a reference to the given string and assigns it to the City field.
func (o *DynamicAddressesListRequest) SetCity(v string) {
	o.City = &v
}

// GetStreet returns the Street field value if set, zero value otherwise.
func (o *DynamicAddressesListRequest) GetStreet() string {
	if o == nil || IsNil(o.Street) {
		var ret string
		return ret
	}
	return *o.Street
}

// GetStreetOk returns a tuple with the Street field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesListRequest) GetStreetOk() (*string, bool) {
	if o == nil || IsNil(o.Street) {
		return nil, false
	}
	return o.Street, true
}

// HasStreet returns a boolean if a field has been set.
func (o *DynamicAddressesListRequest) HasStreet() bool {
	if o != nil && !IsNil(o.Street) {
		return true
	}

	return false
}

// SetStreet gets a reference to the given string and assigns it to the Street field.
func (o *DynamicAddressesListRequest) SetStreet(v string) {
	o.Street = &v
}

// GetHouseNumber returns the HouseNumber field value if set, zero value otherwise.
func (o *DynamicAddressesListRequest) GetHouseNumber() int64 {
	if o == nil || IsNil(o.HouseNumber) {
		var ret int64
		return ret
	}
	return *o.HouseNumber
}

// GetHouseNumberOk returns a tuple with the HouseNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesListRequest) GetHouseNumberOk() (*int64, bool) {
	if o == nil || IsNil(o.HouseNumber) {
		return nil, false
	}
	return o.HouseNumber, true
}

// HasHouseNumber returns a boolean if a field has been set.
func (o *DynamicAddressesListRequest) HasHouseNumber() bool {
	if o != nil && !IsNil(o.HouseNumber) {
		return true
	}

	return false
}

// SetHouseNumber gets a reference to the given int64 and assigns it to the HouseNumber field.
func (o *DynamicAddressesListRequest) SetHouseNumber(v int64) {
	o.HouseNumber = &v
}

// GetHouseNumberVariant returns the HouseNumberVariant field value if set, zero value otherwise.
func (o *DynamicAddressesListRequest) GetHouseNumberVariant() string {
	if o == nil || IsNil(o.HouseNumberVariant) {
		var ret string
		return ret
	}
	return *o.HouseNumberVariant
}

// GetHouseNumberVariantOk returns a tuple with the HouseNumberVariant field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesListRequest) GetHouseNumberVariantOk() (*string, bool) {
	if o == nil || IsNil(o.HouseNumberVariant) {
		return nil, false
	}
	return o.HouseNumberVariant, true
}

// HasHouseNumberVariant returns a boolean if a field has been set.
func (o *DynamicAddressesListRequest) HasHouseNumberVariant() bool {
	if o != nil && !IsNil(o.HouseNumberVariant) {
		return true
	}

	return false
}

// SetHouseNumberVariant gets a reference to the given string and assigns it to the HouseNumberVariant field.
func (o *DynamicAddressesListRequest) SetHouseNumberVariant(v string) {
	o.HouseNumberVariant = &v
}

// GetLat returns the Lat field value if set, zero value otherwise.
func (o *DynamicAddressesListRequest) GetLat() string {
	if o == nil || IsNil(o.Lat) {
		var ret string
		return ret
	}
	return *o.Lat
}

// GetLatOk returns a tuple with the Lat field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesListRequest) GetLatOk() (*string, bool) {
	if o == nil || IsNil(o.Lat) {
		return nil, false
	}
	return o.Lat, true
}

// HasLat returns a boolean if a field has been set.
func (o *DynamicAddressesListRequest) HasLat() bool {
	if o != nil && !IsNil(o.Lat) {
		return true
	}

	return false
}

// SetLat gets a reference to the given string and assigns it to the Lat field.
func (o *DynamicAddressesListRequest) SetLat(v string) {
	o.Lat = &v
}

// GetLng returns the Lng field value if set, zero value otherwise.
func (o *DynamicAddressesListRequest) GetLng() string {
	if o == nil || IsNil(o.Lng) {
		var ret string
		return ret
	}
	return *o.Lng
}

// GetLngOk returns a tuple with the Lng field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesListRequest) GetLngOk() (*string, bool) {
	if o == nil || IsNil(o.Lng) {
		return nil, false
	}
	return o.Lng, true
}

// HasLng returns a boolean if a field has been set.
func (o *DynamicAddressesListRequest) HasLng() bool {
	if o != nil && !IsNil(o.Lng) {
		return true
	}

	return false
}

// SetLng gets a reference to the given string and assigns it to the Lng field.
func (o *DynamicAddressesListRequest) SetLng(v string) {
	o.Lng = &v
}

func (o DynamicAddressesListRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DynamicAddressesListRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Plz) {
		toSerialize["plz"] = o.Plz
	}
	if !IsNil(o.District) {
		toSerialize["district"] = o.District
	}
	if !IsNil(o.City) {
		toSerialize["city"] = o.City
	}
	if !IsNil(o.Street) {
		toSerialize["street"] = o.Street
	}
	if !IsNil(o.HouseNumber) {
		toSerialize["house_number"] = o.HouseNumber
	}
	if !IsNil(o.HouseNumberVariant) {
		toSerialize["house_number_variant"] = o.HouseNumberVariant
	}
	if !IsNil(o.Lat) {
		toSerialize["lat"] = o.Lat
	}
	if !IsNil(o.Lng) {
		toSerialize["lng"] = o.Lng
	}
	return toSerialize, nil
}

type NullableDynamicAddressesListRequest struct {
	value *DynamicAddressesListRequest
	isSet bool
}

func (v NullableDynamicAddressesListRequest) Get() *DynamicAddressesListRequest {
	return v.value
}

func (v *NullableDynamicAddressesListRequest) Set(val *DynamicAddressesListRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableDynamicAddressesListRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableDynamicAddressesListRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDynamicAddressesListRequest(val *DynamicAddressesListRequest) *NullableDynamicAddressesListRequest {
	return &NullableDynamicAddressesListRequest{value: val, isSet: true}
}

func (v NullableDynamicAddressesListRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDynamicAddressesListRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


